/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet.c 101 2015-06-02 15:37:23Z coas-nagasima $
 */

#include <kernel.h>
#include <stdio.h>
#include <string.h>

#include "echonet.h"
#include "echonet_fbs.h"
#include "echonet_task.h"
#include "echonet_dbg.h"
#include "echonet_agent.h"

/*
 * ECHONET LiteT[rXJn
 */
ER ecn_sta_svc()
{
	return act_tsk(ecn_udp_taskid);
}

/*
 * ECHONETIuWFNgQ
 * 
 * ID		fa_eobjid	ECHONETIuWFNgID
 * T_REOBJ	*fp_eobj	ECHONETIuWFNg̐ݒeRs[
 *
 * eobjidŎw肵ECHONETIuWFNg̐ݒeQƂB
 * QƂݒepk_eobjɎw肵ɕԂB
 */
ER ecn_ref_eobj(ID fa_eobjid, T_REOBJ *fp_eobj)
{
	const EOBJINIB	*p_obj;

	if (!fp_eobj)
		return E_PAR;	/* p[^G[ */

	if ((fa_eobjid <= 0) || (fa_eobjid > tmax_eobjid))
		return E_OBJ;	/* IuWFNgo^ */

	p_obj = &eobjinib_table[fa_eobjid - 1];

	*fp_eobj = *p_obj;

	return E_OK;
}

/*
 * ECHONETvpeBQ
 * 
 * ID			fa_eobjid	ECHONETIuWFNgID
 * uint8_t		fa_epc		vpeBR[h
 * T_RPRP		*fp_eprp	ECHONETIuWFNg̃vpeBݒeRs[
 *
 * eobjidŎw肵ECHONETIuWFNǵAepcŎw肵vpeB̐ݒeQƂB
 * QƂݒepk_eprpɎw肵ɕԂB
 */
ER ecn_ref_eprp(ID fa_eobjid, uint8_t fa_epc, T_RPRP *fp_eprp)
{
	const EOBJINIB	*p_obj;
	const EPRPINIB	*p;
	uint_t			i;

	if (!fp_eprp)
		return E_PAR;	/* p[^G[ */

	if ((fa_eobjid <= 0) || (fa_eobjid > tmax_eobjid))
		return E_OBJ;	/* IuWFNgo^ */

	p_obj = &eobjinib_table[fa_eobjid - 1];

	/* eoj̎vpeB`z񂩂猟 */
	p = p_obj->eprp;
	for (i = 0; i < p_obj->eprpcnt; i++, p++) {
		if (p->eprpcd != fa_epc)
			continue;
		*fp_eprp = *p;
		return E_OK;
	}

	return E_PAR;	/* p[^G[ */
}

/*
 * vpeBlݗvisvjd쐬
 * 
 * T_EDATA			**ppk_esv	擾d̊i[
 * ID				fa_deoj		ECHONETIuWFNgID
 * uint8_t			fa_epc		vpeBR[h
 * uint8_t			fa_pdc		vpeBlf[^TCY
 * const void		*p_edt		vpeBlf[^
 *
 *	vpeBlݗvisvjd쐬B
 *	ddeojŎw肵ECHONETIuWFNgƂA
 *	d̏߂̃vpeBlƂāAepcpdcAp_edtŎw肳ꂽ
 *	vpeBR[hAf[^TCYAf[^dɐݒ肷B
 *	쐬d̐擪AhX̓|C^oRŕԂB
 */
ER ecn_esv_seti(T_EDATA **ppk_esv, ID fa_deoj, uint8_t fa_epc, uint8_t fa_pdc,
	const void *p_edt)
{
	return _ecn_tsk_mk_esv((ECN_FBS_ID *)ppk_esv, (ID)1, fa_deoj, fa_epc, fa_pdc, p_edt, ESV_SET_I);
}

/*
 * vpeBlݗvivjd쐬
 * 
 * T_EDATA			**ppk_esv	擾d̊i[
 * ID				fa_deoj		ECHONETIuWFNgID
 * uint8_t			fa_epc		vpeBR[h
 * uint8_t			fa_pdc		vpeBlf[^TCY
 * const void		*p_edt		vpeBlf[^
 *
 *	vpeBlݗvivjd쐬B
 *	ddeojŎw肵ECHONETIuWFNgƂA
 *	d̏߂̃vpeBlƂāAepcpdcAp_edtŎw肳ꂽ
 *	vpeBR[hAf[^TCYAf[^dɐݒ肷B
 *	쐬d̐擪AhX̓|C^oRŕԂB
 */
ER ecn_esv_setc(T_EDATA **ppk_esv, ID fa_deoj, uint8_t fa_epc, uint8_t fa_pdc,
	const void *p_edt)
{
	return _ecn_tsk_mk_esv((ECN_FBS_ID *)ppk_esv, (ID)1, fa_deoj, fa_epc, fa_pdc, p_edt, ESV_SET_C);
}

/*
 * vpeBlǂݏovd쐬
 * 
 * T_EDATA			**ppk_esv	擾d̊i[
 * ID				fa_deoj		ECHONETIuWFNgID
 * uint8_t			fa_epc		vpeBR[h
 *
 * vpeBlǂݏovd쐬B
 * ddeojŎw肵ECHONETIuWFNgƂA
 * d̏߂̃vpeBlƂāAepcŎw肳ꂽ
 * vpeBR[hdɐݒ肷B
 * 쐬d̐擪AhX̓|C^oRŕԂB
 */
ER ecn_esv_get(T_EDATA **ppk_esv, ID fa_deoj, uint8_t fa_epc)
{
	return _ecn_tsk_mk_esv((ECN_FBS_ID *)ppk_esv, (ID)1, fa_deoj, fa_epc, 0, NULL, ESV_GET);
}

/*
 * vpeBlʒmvd쐬
 * 
 * T_EDATA			**ppk_esv	擾d̊i[
 * ID				fa_deoj		ECHONETIuWFNgID
 * uint8_t			fa_epc		vpeBR[h
 *
 * vpeBlʒmvd쐬B
 * ddeojŎw肵ECHONETIuWFNgƂA
 * d̏߂̃vpeBlƂāAepcŎw肳ꂽ
 * vpeBR[hdɐݒ肷B
 * 쐬d̐擪AhX̓|C^oRŕԂB
 */
ER ecn_esv_inf_req(T_EDATA **ppk_esv, ID fa_deoj, uint8_t fa_epc)
{
	return _ecn_tsk_mk_esv((ECN_FBS_ID *)ppk_esv, (ID)1, fa_deoj, fa_epc, 0, NULL, ESV_INF_REQ);
}

/*
 * vpeBl݁Eǂݏovd쐬
 * 
 * T_EDATA			**ppk_esv	擾d̊i[
 * ID				fa_deoj		ECHONETIuWFNgID
 * uint8_t			fa_epc		vpeBR[h
 * uint8_t			fa_pdc		vpeBlf[^TCY
 * const void		*p_edt		vpeBlf[^
 *
 * vpeBl݁Eǂݏovd쐬B
 * ddeojŎw肵ECHONETIuWFNgƂA
 * d̏߂̃vpeBlƂāAepcpdcAp_edtŎw肳ꂽ
 * vpeBR[hAf[^TCYAf[^dɐݒ肷B
 * 쐬d̐擪AhX̓|C^oRŕԂB
 */
ER ecn_esv_set_get(T_EDATA **ppk_esv, ID fa_deoj, uint8_t fa_epc, uint8_t fa_pdc,
	const void *p_edt)
{
	return _ecn_tsk_mk_esv((ECN_FBS_ID *)ppk_esv, (ID)1, fa_deoj, fa_epc, fa_pdc, p_edt, ESV_SET_GET);
}

/*
 * vpeBl݁Eǂݏovd쐬F܂Ԃw
 * vpeBl݁Eǂݏovd쐬́A݃vpeBzI
 * ǂݏovpeBzɈڂ鎞ɗpB
 */
ER ecn_trn_set_get(T_EDATA *ppk_esv, int *p_trn_pos)
{
	ER	a_ret;

	if (!ppk_esv)
		return E_PAR;
	if (!p_trn_pos)
		return E_PAR;

	/* vpeBǂݍ݌ݎ̃wbhL^ */
	*p_trn_pos = _ecn_fbs_get_datalen(*(ECN_FBS_ID *)&ppk_esv);

	/* dpɃf[^ǉE̎_ł̉dvpeBL^ */
	a_ret = _ecn_fbs_add_data_ex(*(ECN_FBS_ID *)&ppk_esv, &ppk_esv->hdr.edata.opc, 1);
	if (a_ret) {
		ECN_DBG_PUT "ecn_trn_set_get(): _ecn_fbs_add_data_ex() result = %d:%s", a_ret, itron_strerror(a_ret) ECN_DBG_END;
		return a_ret;
	}

	/* dvpeB 0 ɖ߂iAIw肷܂ł͓ǂݏovpeBɂȂj */
	ppk_esv->hdr.edata.opc = 0;

	return E_OK;
}

/*
 * vpeBl݁Eǂݏovd쐬FIw
 * vpeBl݁Eǂݏovd쐬́AǂݏovpeBzI鎞ɗpB
 */
ER ecn_end_set_get(T_EDATA *ppk_esv, int fa_trn_pos)
{
	ER		a_ret;
	int		a_wr_opc;
	uint8_t	a_rd_opc;

	if (!ppk_esv)
		return E_PAR;

	/* ̎_ł̉dvpeB(ǂݏovpeB)ێ */
	a_rd_opc = ppk_esv->hdr.edata.opc;

	/* dvpeB(݃vpeB)ۑʒuǂݎ */
	a_wr_opc = _ecn_fbs_peek(*(ECN_FBS_ID *)&ppk_esv, fa_trn_pos);
	if (a_wr_opc < 0) {
		ECN_DBG_PUT "ecn_end_set_get(): _ecn_fbs_peek() result = %d:%s", a_wr_opc, itron_strerror(a_wr_opc) ECN_DBG_END;
		return a_wr_opc;
	}

	/* dvpeB(݃vpeB)𕜌 */
	ppk_esv->hdr.edata.opc = (uint8_t)a_wr_opc;

	/* dvpeB(ǂݏovpeB)ۑʒuɏ */
	a_ret = _ecn_fbs_poke(*(ECN_FBS_ID *)&ppk_esv, fa_trn_pos, a_rd_opc);
	if (a_ret) {
		ECN_DBG_PUT "ecn_end_set_get(): _ecn_fbs_poke() result = %d:%s", a_ret, itron_strerror(a_ret) ECN_DBG_END;
		return a_ret;
	}

	return E_OK;
}

/*
 * vpeBlʒmivjd쐬
 * 
 * T_EDATA			**ppk_esv	擾d̊i[
 * ID				fa_deoj		ECHONETIuWFNgID
 * ID				fa_seoj		MECHONETIuWFNgID
 * uint8_t			fa_sepc		M̃vpeBR[h
 */
ER ecn_esv_infc(T_EDATA **ppk_esv, ID fa_deoj, ID fa_seoj, uint8_t fa_sepc)
{
	return _ecn_tsk_mk_esv((ECN_FBS_ID *)ppk_esv, fa_seoj, fa_deoj, fa_sepc, 0, NULL, ESV_INFC);
}

/*
 * vdւ̃vpeBwǉ (vpeBf[^tȂꍇɗp)
 */
ER ecn_add_epc(T_EDATA *pk_esv, uint8_t epc)
{
	return ecn_add_edt(pk_esv, epc, 0, 0);
}

/*
 * vdւ̃vpeBf[^ǉ (vpeBѕtf[^ǉ)
 */
ER ecn_add_edt(T_EDATA *pk_esv, uint8_t fa_epc, uint8_t fa_pdc, const void *p_edt)
{
	ECN_FBS_ID	a_fbs_id;
	ER			a_ret;
	T_ECN_PRP	a_ecn_prp;

	if (!pk_esv)
		return E_PAR; /* 擾FBS_ID̊i[悪NULL */
	if (ECHONET_MEMPOOL_BLOCK_SIZE <= fa_pdc)
		return E_PAR; /* vpeBlTCY傫 */
	if (!p_edt && 0 < fa_pdc)
		return E_PAR; /* vpeBlTCY1ȏȂ̂Ƀf[^|C^NULL */

	a_fbs_id.ptr = (T_ECN_FST_BLK *)pk_esv;
	if (((T_EDATA *)a_fbs_id.ptr)->hdr.edata.opc == 0xFF)
		return E_PAR; /* vpeB */

	/* vdpɃf[^ǉ */
	memset(&a_ecn_prp, 0, sizeof(a_ecn_prp));
	a_ecn_prp.epc = fa_epc;
	a_ecn_prp.pdc = fa_pdc;
	a_ret = _ecn_fbs_add_data_ex(a_fbs_id, &a_ecn_prp, sizeof(a_ecn_prp));
	if (a_ret) {
		ECN_DBG_PUT "ecn_add_edt(): _ecn_fbs_add_data_ex(*, ecn_prp{epc:0x%02X}, %u) result = %d:%s",
			a_ecn_prp.epc, sizeof(a_ecn_prp),
			a_ret, itron_strerror(a_ret) ECN_DBG_END;
		goto lb_except;
	}
	if (0 < fa_pdc) {
		/* tf[^ǉ */
		a_ret = _ecn_fbs_add_data_ex(a_fbs_id, p_edt, fa_pdc);
		if (a_ret) {
			ECN_DBG_PUT "ecn_add_edt(): _ecn_fbs_add_data_ex(*, ecn_prp{epc:0x%02X} edt, %u) result = %d:%s",
				a_ecn_prp.epc, fa_pdc,
				a_ret, itron_strerror(a_ret) ECN_DBG_END;
			goto lb_except;
		}
	}
	/* vpeBCNg */
	((T_EDATA *)a_fbs_id.ptr)->hdr.edata.opc++;

lb_except:
	return a_ret;
}

/*
 * vd̑M
 * esvŎw肳ꂽvd𑗐MB
 * dɎw肳ꂽ悩IPAhX肵AUDPpPbgƂđMB
 */
ER ecn_snd_esv(T_EDATA *pk_esv)
{
	ECN_FBS_ID a_rsp_fbs;
	a_rsp_fbs.ptr = (T_ECN_FST_BLK *)pk_esv;
	return _ecn_tsk_snd_mbx(a_rsp_fbs, true);
}

/*
 * d̎M|[O
 * dM̂҂B
 * Mdppk_esvŎw肵|C^[ɐ擪AhXԂB
 * d̎M̗Lɂ炸A҂Ɋ֐𔲂B
 */
ER ecn_prcv_esv(T_EDATA **ppk_esv)
{
	intptr_t	p_msg = 0;
	ER		a_ret;

	if (!ppk_esv)
		return E_PAR;

	a_ret = prcv_dtq(ecn_api_mailboxid, &p_msg);
	if (a_ret != E_OK) {
		*ppk_esv = NULL;
		return a_ret;
	}

	*ppk_esv = (T_EDATA *)p_msg;
	return (((T_ECN_FST_BLK *)p_msg)->hdr.type == ECN_MSG_ECHONET) ? E_OK : E_BRK;
}

/*
 * d̔j
 */
ER ecn_rel_esv(T_EDATA *pk_esv)
{
	ECN_FBS_ID	a_fbs;
	ER			a_ret;

	a_fbs.ptr = (T_ECN_FST_BLK *)pk_esv;
	a_ret = _ecn_fbs_del(a_fbs);
	return a_ret;
}

/*
 * d̑Mm[h擾
 */
ID ecn_get_enod(T_EDATA *pk_esv)
{
	const EOBJCB	*p_snod;
	const EOBJINIB	*p_sobj = NULL;
	T_ECN_EDT_HDR	*p_esv;

	p_esv = &pk_esv->hdr;
	p_snod = _ecn_eno_fnd(((T_ECN_FST_BLK *)pk_esv)->hdr.sender);
	if (p_snod != NULL) {
		p_sobj = p_snod->profile;
	}

	if (p_sobj == NULL)
		return EOBJ_NULL;
#ifdef ECHONET_CONTROLLER_EXTENTION
	if (p_sobj->eprpcnt == 0)
		return ecn_agent_get_eobj(p_sobj);
#endif
	return 1 + (((intptr_t)p_sobj - (intptr_t)eobjinib_table) / sizeof(EOBJINIB));
}

/*
 * d̑M@IuWFNg擾
 */
ID ecn_get_eobj(T_EDATA *pk_esv)
{
	const EOBJCB	*p_snod;
	const EOBJINIB	*p_sobj = NULL;
	T_ECN_EDT_HDR	*p_esv;

	p_esv = &pk_esv->hdr;
	p_snod = _ecn_eno_fnd(((T_ECN_FST_BLK *)pk_esv)->hdr.sender);
	if (p_snod != NULL) {
		/* m[hvt@C̏ꍇ */
		if ((p_esv->edata.seoj.eojx1 == EOJ_X1_PROFILE)
			&& (p_esv->edata.seoj.eojx2 == EOJ_X2_NODE_PROFILE)) {
			p_sobj = p_snod->profile;
		}
		/* @IuWFNg̏ꍇ */
		else {
			p_sobj = _ecn_eoj_fnd(p_snod, &p_esv->edata.seoj);
		}
	}

	if (p_sobj == NULL)
		return EOBJ_NULL;
#ifdef ECHONET_CONTROLLER_EXTENTION
	if (p_sobj->eprpcnt == 0)
		return ecn_agent_get_eobj(p_sobj);
#endif
	return 1 + (((intptr_t)p_sobj - (intptr_t)eobjinib_table) / sizeof(EOBJINIB));
}

/*
 * d̓Ce[^[
 */
ER ecn_itr_ini(T_ENUM_EPC *pk_itr, T_EDATA *pk_esv)
{
	if (!pk_itr)
		return E_PAR;
	if (!pk_esv)
		return E_PAR;

	memset(pk_itr, 0, sizeof(*pk_itr));
	pk_itr->pk_esv = pk_esv;
	pk_itr->count = pk_esv->hdr.edata.opc;
								/* ̃ubNł̃vpeB */
	pk_itr->got_ct = 0;			/* ̃ubNŁAǂݎ */
	pk_itr->next_blk_ct = 0;	/* 㑱ubN */
	pk_itr->is_eof = 0;			/* I[ɒBA0 */
	pk_itr->cur = offsetof(T_ECN_EDT_HDR, ecn_prp);

	switch (pk_esv->hdr.edata.esv) {
	case ESV_SET_GET:		/* 0x6E vpeBl݁Eǂݏov		*/
	case ESV_SET_GET_RES:	/* 0x7E vpeBl݁Eǂݏo		*/
	case ESV_SET_GET_SNA:	/* 0x5E	vpeBl݁Eǂݏos	*/
		pk_itr->next_blk_ct ++;
	default:
		break;
	}

	return E_OK;
}

/*
 * d̓Ce[^[CNg
 */
ER ecn_itr_nxt(T_ENUM_EPC *pk_itr, uint8_t *p_epc, uint8_t *p_pdc, void *p_edt)
{
	ECN_FBS_ID		a_fbs_id;
	int				a_rd_bak;
	ER				a_ret;
	ECN_FBS_SSIZE_T	a_rd_len;
	T_ECN_PRP		a_ecn_prp;

	if (!pk_itr)
		return E_PAR;
	if (!p_epc)
		return E_PAR;
	if (!p_pdc)
		return E_PAR;
	if (!p_edt)
		return E_PAR;
	if (!pk_itr->pk_esv)
		return E_PAR;

	if (pk_itr->is_eof)
		return E_BOVR; /* f[^I */
	if (	pk_itr->count <= pk_itr->got_ct
	&&	pk_itr->next_blk_ct < 1) {
		pk_itr->is_eof = 1;			/* I[ɒBA0 */
		return E_BOVR; /* f[^I */
	}

	a_fbs_id.ptr = (T_ECN_FST_BLK *)pk_itr->pk_esv;

	/* ̃J[\ʒuۑACe[^̃J[\ʒuɂ */
	a_rd_bak = a_fbs_id.ptr->hdr.rd;
	a_fbs_id.ptr->hdr.rd = pk_itr->cur;

#ifdef ECN_ENA_ITR_NXT_CARP
	ECN_CAP_PUT "ecn_itr_nxt() rd.cur=b%dp%d", pk_itr->cur.blk, pk_itr->cur.pos ECN_CAP_PUT;
#endif
	if (pk_itr->count <= pk_itr->got_ct && 0 < pk_itr->next_blk_ct) {
		/* ubNɈړ */
		pk_itr->next_blk_ct --;
		pk_itr->count = 0;		/* ̃ubNł̃vpeB */
		pk_itr->got_ct = 0;		/* ̃ubNŁAǂݎ */

		/* ubÑvpeBǂݎ */
		a_rd_len = 0;
		a_ret = _ecn_fbs_get_data(a_fbs_id, &a_ecn_prp.pdc, 1, &a_rd_len);
		if (a_ret != E_OK)
			goto lb_except;
		if (0 < a_rd_len) {
			pk_itr->count = a_ecn_prp.pdc;	/* ̃ubNł̃vpeB */
		}
		a_ret = E_BOVR;	/* f[^I */
		goto lb_finally;
	}

	/* vpeBR[hƃf[^TCYǂݎ */
	memset(&a_ecn_prp, 0, sizeof(a_ecn_prp));
	a_rd_len = 0;
	a_ret = _ecn_fbs_get_data(a_fbs_id, &a_ecn_prp, sizeof(a_ecn_prp), &a_rd_len);
	if (a_ret != E_OK)
		goto lb_except;
	if (a_rd_len < sizeof(a_ecn_prp)) {
		ECN_DBG_PUT "ecn_itr_nxt() ecn_prp read fault." 
			" rd.cur=%d", pk_itr->cur ECN_DBG_END;
		pk_itr->is_eof = 1;			/* I[ɒBA0 */
		a_ret = E_BOVR;	/* f[^I */
		goto lb_finally;
	}
	*p_epc = a_ecn_prp.epc;
	*p_pdc = a_ecn_prp.pdc;

	if (0 < a_ecn_prp.pdc) {
		/* tf[^ǂݎ */
		a_rd_len = 0;
		a_ret = _ecn_fbs_get_data(a_fbs_id, p_edt, a_ecn_prp.pdc, &a_rd_len);
		if (a_ret != E_OK)
			goto lb_except;
		if (a_rd_len < (ECN_FBS_SSIZE_T)a_ecn_prp.pdc) {
			ECN_DBG_PUT "ecn_itr_nxt() edt read fault."
				" rd.cur=%d,epc=0x%02X,pdc=%u", pk_itr->cur, a_ecn_prp.epc , a_ecn_prp.pdc ECN_DBG_END;
			pk_itr->is_eof = 1;			/* I[ɒBA0 */
			a_ret = E_BOVR;	/* f[^I */
			goto lb_finally;
		}
	}
	pk_itr->got_ct++;

#ifdef ECN_ENA_ITR_NXT_CARP
	ECN_CAP_PUT "ecn_itr_nxt() read: ct=%d/%d", pk_itr->got_ct, pk_itr->count ECN_CAP_PUT;
#endif

lb_finally:
	/* Ce[^̃J[\ʒuXV */
	pk_itr->cur = a_fbs_id.ptr->hdr.rd;

lb_except:
	/* ̃J[\ʒuɖ߂ */
	a_fbs_id.ptr->hdr.rd = a_rd_bak;
	return a_ret;
}

/*
 * d҂̊荞ݑM
 */
ER ecn_brk_wai(const void *p_dat, int fa_datsz)
{
	ER				a_ret;
	ECN_FBS_ID		a_fbs_id = { 0 };	/* vdp	*/

	/* d҂̊荞ݓd쐬 */
	a_ret = _ecn_mk_brk_wai(&a_fbs_id, p_dat, fa_datsz);
	if (a_ret)
		return a_ret;

	/* 荞ݑM */
	a_ret = _ecn_tsk_snd_mbx(a_fbs_id, true);
	if (a_ret) {
		ECN_DBG_PUT "_ecn_tsk_snd_mbx() result = %d:%s",
			a_ret, itron_strerror(a_ret) ECN_DBG_END;
		goto lb_except;
	}

	/* I */
	return a_ret;

lb_except:
	/* f[^쐬s̈ */
	if (a_fbs_id.ptr)
		_ecn_fbs_del(a_fbs_id);

	return a_ret;
}

/*
 * 荞݃f[^̎擾
 */
ER ecn_get_brk_dat(T_EDATA *pk_esv, void *p_buf, int fa_bufsz, int *p_datsz)
{
	ECN_FBS_ID	a_fbs;
	ER			a_ret;
	ECN_FBS_SSIZE_T		a_len;

	if (p_datsz)
		*p_datsz = 0;
	if (!pk_esv)
		return E_PAR;

	a_fbs.ptr = (T_ECN_FST_BLK *)pk_esv;
	if (a_fbs.ptr->hdr.type != ECN_MSG_USER_BREAK) {
		ECN_DBG_PUT "ecn_get_brk_dat: fbs-type:%d != ECN_MSG_USER_BREAK",
			a_fbs.ptr->hdr.type ECN_DBG_END;
		return E_PAR;
	}

	/* ǂݎʒu擪ɖ߂ */
	a_ret = _ecn_fbs_set_rpos(a_fbs, 0);
	if (a_ret) {
		ECN_DBG_PUT "_ecn_fbs_set_rpos(*, 0) result = %d:%s",
			a_ret, itron_strerror(a_ret) ECN_DBG_END;
		return a_ret;
	}

	/* tf[^ǂݍ */
	if (p_buf && 0 < fa_bufsz) {
		a_len = 0;
		a_ret = _ecn_fbs_get_data(a_fbs, p_buf, fa_bufsz, &a_len);
		if (a_ret || !a_len) {
			ECN_DBG_PUT "_ecn_fbs_get_data(*, p_buf, fa_bufsz) result = %d:%s",
				a_ret, itron_strerror(a_ret) ECN_DBG_END;
			return E_PAR;
		}
		*p_datsz = a_len;
	}

	return E_OK;
}

#ifndef ECN_USER_DATA_PROP_SET
/*
 * f[^ݒ֐
 */
int ecn_data_prop_set(const EPRPINIB *item, const void *src, int size, bool_t *anno)
{
	if (size > item->eprpsz)
		size = item->eprpsz;

	if (*anno)
		*anno = memcmp((uint8_t *)item->exinf, src, size) != 0;

	memcpy((uint8_t *)item->exinf, src, size);

	return size;
}
#endif

#ifndef ECN_USER_DATA_PROP_GET
/*
 * f[^擾֐
 */
int ecn_data_prop_get(const EPRPINIB *item, void *dst, int size)
{
	if (size > item->eprpsz)
		size = item->eprpsz;

	memcpy(dst, (uint8_t *)item->exinf, size);

	return size;
}
#endif
