/*
 *  TOPPERS ECHONET Lite Communication Middleware
 *
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  @(#) $Id: kadecot_names.c 101 2015-06-02 15:37:23Z coas-nagasima $
 */

#include <string.h>
#ifndef _MSC_VER
#include <t_stddef.h>
#else
#include <stdint.h>
typedef int bool_t;
#define false ((bool_t)0)
#define true ((bool_t)1)
#endif
#include "kadecot_names.h"

uint16_t kadecot_names_get_device_type(const char *name, int nameLen);
bool_t kadecot_names_get_device_type_name(uint16_t deviceType, char *buf, int bufLen);
uint8_t kadecot_names_get_property_code(const char *name, int nameLen,
	uint16_t devType);
static uint16_t get_device_type(uint8_t *table, int len,
	const char *name, int nameLen);
static bool_t get_device_type_name(uint8_t *table, int len, uint16_t deviceType,
	uint8_t *strtable, int stablelen, char *buf, int bufLen);
static uint8_t get_property_code(uint8_t *table, int len,
	const char *name, int nameLen, uint16_t devType);
static uint8_t get_prop_code(uint8_t *table, int len, const char *name, int nameLen,
	uint16_t devType, int pos);

#ifndef _MSC_VER
#define KADECOT_NAMES_TABLE ((uint8_t *)0xFFFE0000)
#else
#undef SIZE
#include <windows.h>
#include <tchar.h>
#include <winioctl.h>

uint8_t KADECOT_NAMES_TABLE[0x5000];
#endif
static int devTableLen;
static uint8_t *devTable;
static int devCodeTableLen;
static uint8_t *devCodeTable;
static int propTableLen;
static uint8_t *propTable;

void kadecot_names_init()
{
	int pos;
#ifdef _MSC_VER
	HANDLE h;
	DWORD br;

	h = CreateFile(_T("..\\..\\..\\..\\kadecot\\kadecot_names.bin"), GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
	if (h == INVALID_HANDLE_VALUE) {
		return;
	}

	ReadFile(h, KADECOT_NAMES_TABLE, sizeof(KADECOT_NAMES_TABLE), &br, 0);
	CloseHandle(h);
#endif
	devTableLen = (KADECOT_NAMES_TABLE[0] << 8) | KADECOT_NAMES_TABLE[1];
	devTable = &KADECOT_NAMES_TABLE[2];
	pos = devTableLen + 2;
	devCodeTableLen = (KADECOT_NAMES_TABLE[pos] << 8) | KADECOT_NAMES_TABLE[pos + 1];
	devCodeTable = &KADECOT_NAMES_TABLE[pos + 2];
	pos += devCodeTableLen + 2;
	propTableLen = (KADECOT_NAMES_TABLE[pos] << 8) | KADECOT_NAMES_TABLE[pos + 1];
	propTable = &KADECOT_NAMES_TABLE[pos + 2];
}

uint16_t kadecot_names_get_device_type(const char *name, int nameLen)
{
	return get_device_type(devTable, devTableLen, name, nameLen);
}

bool_t kadecot_names_get_device_type_name(uint16_t deviceType, char *buf, int bufLen)
{
	return get_device_type_name(devCodeTable, devCodeTableLen, deviceType,
		devTable, devTableLen, buf, bufLen);
}

uint8_t kadecot_names_get_property_code(const char *name, int nameLen,
	uint16_t devType)
{
	return get_property_code(propTable, propTableLen, name, nameLen, devType);
}

static uint16_t get_device_type(uint8_t *table, int len, const char *name, int nameLen)
{
	int pos = 0, nextpos, i = 0;
	uint8_t count;
	uint16_t DeviceType;

	while (pos < len) {
		/* branch count */
		count = table[pos++];

		/* [̃m[h */
		if (count == 0) {
			/* NULL܂߂TCY */
			if(i != (nameLen + 1))
				return 0;

			DeviceType = table[pos++] << 8;
			DeviceType |= table[pos++];

			return DeviceType;
		}

		for (;;) {
			int length, start = pos, j, k;
			/* string length */
			length = table[pos++];
			for (j = 0, k = i; j < length; j++, k++) {
				/* NULL܂߂`FbN */
				if((k > nameLen) || (table[pos++] != name[k])){
					pos = start + 1 + length + 2;
					goto nextnode;
				}
			}
			i += length;

			/* nextpos */
			nextpos = table[pos++] << 8;
			nextpos |= table[pos++];

			pos = nextpos;
			break;
		nextnode:
			count--;
			if (count == 0)
				return 0;
			continue;
		}
	}

	return 0;
}

static bool_t get_device_type_name(uint8_t *table, int len, uint16_t deviceType,
	uint8_t *strtable, int stablelen, char *buf, int bufLen)
{
	int pos = 0, i, unmatchpos;

	while (pos < len) {
		uint16_t mask, ptrn;
		/* bit mask */
		mask = table[pos++] << 8;
		mask |= table[pos++];
		/* bit pattarn */
		ptrn = table[pos++] << 8;
		ptrn |= table[pos++];
		/* unmatchpos */
		unmatchpos = table[pos++] << 8;
		unmatchpos |= table[pos++];

		if ((mask & deviceType) != ptrn) {
			if (unmatchpos == 0)
				return false;
			pos = unmatchpos;
			continue;
		}

		/* [̃m[h */
		if ((mask & 0x0001) != 0) {
			int bufpos = 0;
			int count = table[pos++];
			for (i = 0; i < count; i++) {
				int substr, strlen, end;

				substr = table[pos++] << 8;
				substr |= table[pos++];

				if (substr > stablelen)
					return false;

				strlen = strtable[substr++];
				if ((substr + strlen) > stablelen)
					return false;

				end = bufpos + strlen;
				if (end > bufLen)
					return false;

				for (; bufpos < end; bufpos++) {
					buf[bufpos] = (char)strtable[substr++];
				}
			}

			return true;
		}
	}

	return false;
}

static uint8_t get_property_code(uint8_t *table, int len, const char *name,
	int nameLen, uint16_t devType)
{
	int pos = 0, nextpos, i = 0;
	uint8_t count;
	uint8_t epc;

	while (pos < len) {
		/* branch count */
		count = table[pos++];

		/* [̃m[h */
		if (count == 0) {
			/* NULL܂߂TCY */
			if(i != (nameLen + 1))
				return 0;

			epc = get_prop_code(table, len, name, nameLen, devType, pos);
			return epc;
		}

		for (;;) {
			int length, start = pos, j, k;
			/* string length */
			length = table[pos++];
			for (j = 0, k = i; j < length; j++, k++) {
				/* NULL܂߂`FbN */
				if((k > nameLen) || (table[pos++] != name[k])){
					pos = start + 1 + length + 2;
					goto nextnode;
				}
			}
			i += length;

			/* nextpos */
			nextpos = table[pos++] << 8;
			nextpos |= table[pos++];

			pos = nextpos;
			break;
		nextnode:
			count--;
			if (count == 0)
				return 0;
			continue;
		}
	}

	return 0;
}

static uint8_t get_prop_code(uint8_t *table, int len, const char *name,
	int nameLen, uint16_t devType, int pos)
{
	int i, start;
	uint8_t count;
	uint8_t epc;
	uint16_t type;

	while (pos < len) {
		/* branch count */
		count = table[pos++];

		/* [̃m[h */
		if (count == 0) {
			epc = table[pos++];
			return epc;
		}

		start = pos;
		for (i = 0; i < count; i++) {
			type = table[pos++] << 8;
			type |= table[pos++];
			if (type == devType) {
				epc = table[start + 2 * count];
				return epc;
			}
		}
		pos++;
	}

	epc = table[pos];
	return epc;
}
