/*
 *  TOPPERS ECHONET Lite Communication Middleware
 *
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  @(#) $Id: wamp_router.h 101 2015-06-02 15:37:23Z coas-nagasima $
 */

#ifndef WAMP_ROUTER_H
#define WAMP_ROUTER_H

typedef enum wamp_router_roles {
	WAMP_ROUTER_ROLES_PUBLISHER = 1,
	WAMP_ROUTER_ROLES_SUBSCRIBER = 2,
	WAMP_ROUTER_ROLES_CALLER = 4,
	WAMP_ROUTER_ROLES_CALLEE = 8,
	WAMP_ROUTER_ROLES_IN_GETTING = 0x80,
} wamp_router_roles_t;

typedef struct wamp_session
{
	struct wamp_router *router;
	int id;
	char realm[80];
	wamp_router_roles_t roles;
} wamp_session_t;

typedef struct wamp_router
{
	struct wamp_state *s;
	wamp_session_t sessions[1];
	wamp_session_t *current_session;
	int session_id;
} wamp_router_t;

wamp_session_t *wamp_router_hello(wamp_router_t *router);
void wamp_router_hello_realm(wamp_router_t *router, const char *value);
void wamp_router_hello_details_param(wamp_router_t *router, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_router_hello_details(wamp_router_t *router);
void wamp_router_hello_close(struct wamp_state *s);

void wamp_router_authenticate(wamp_router_t *router);
void wamp_router_authenticate_signature(wamp_router_t *router, const char *value);
void wamp_router_authenticate_extra(wamp_router_t *router, const char *value);
void wamp_router_authenticate_extra_param(wamp_router_t *router, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_router_authenticate_close(struct wamp_state *s);

void wamp_router_goodbye(wamp_router_t *router);
void wamp_router_goodbye_details_param(wamp_router_t *router, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_router_goodbye_details(wamp_router_t *router);
void wamp_router_goodbye_reason(wamp_router_t *router, const char *value);
void wamp_router_goodbye_close(struct wamp_state *s);

#endif // WAMP_ROUTER_H
